Class: Bundler::CLI::Install

Inherits:
Object
  • Object
show all
Defined in:
lib/bundler/cli/install.rb

Instance Attribute Summary collapse

Instance Method Summary collapse

Constructor Details

#initialize(options) ⇒ Install

Returns a new instance of Install.


4
5
6
# File 'lib/bundler/cli/install.rb', line 4

def initialize(options)
  @options = options.dup
end

Instance Attribute Details

#optionsObject (readonly)

Returns the value of attribute options


3
4
5
# File 'lib/bundler/cli/install.rb', line 3

def options
  @options
end

Instance Method Details

#runObject


8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
67
68
69
70
71
72
73
74
75
76
77
78
79
80
81
82
83
84
85
86
87
88
89
90
91
92
93
94
95
96
97
98
99
100
101
102
103
104
105
106
107
108
109
110
111
112
113
114
115
116
117
118
119
120
121
122
123
124
125
126
# File 'lib/bundler/cli/install.rb', line 8

def run
  Bundler.ui.level = "error" if options[:quiet]

  warn_if_root

  if options[:without]
    options[:without] = options[:without].map{|g| g.tr(' ', ':') }
  end

  ENV['RB_USER_INSTALL'] = '1' if Bundler::FREEBSD

  # Just disable color in deployment mode
  Bundler.ui.shell = Thor::Shell::Basic.new if options[:deployment]

  if (options[:path] || options[:deployment]) && options[:system]
    Bundler.ui.error "You have specified both a path to install your gems to, \n" \
                     "as well as --system. Please choose."
    exit 1
  end

  if (options["trust-policy"])
    unless (Bundler.rubygems.security_policies.keys.include?(options["trust-policy"]))
      Bundler.ui.error "Rubygems doesn't know about trust policy '#{options["trust-policy"]}'. " \
        "The known policies are: #{Bundler.rubygems.security_policies.keys.join(', ')}."
      exit 1
    end
    Bundler.settings["trust-policy"] = options["trust-policy"]
  else
    Bundler.settings["trust-policy"] = nil if Bundler.settings["trust-policy"]
  end

  if options[:deployment] || options[:frozen]
    unless Bundler.default_lockfile.exist?
      flag = options[:deployment] ? '--deployment' : '--frozen'
      raise ProductionError, "The #{flag} flag requires a Gemfile.lock. Please make " \
                             "sure you have checked your Gemfile.lock into version control " \
                             "before deploying."
    end

    if Bundler.root.join("vendor/cache").exist?
      options[:local] = true
    end

    Bundler.settings[:frozen] = '1'
  end

  # When install is called with --no-deployment, disable deployment mode
  if options[:deployment] == false
    Bundler.settings.delete(:frozen)
    options[:system] = true
  end

  Bundler.settings[:path]     = nil if options[:system]
  Bundler.settings[:path]     = "vendor/bundle" if options[:deployment]
  Bundler.settings[:path]     = options["path"] if options["path"]
  Bundler.settings[:path]     ||= "bundle" if options["standalone"]
  Bundler.settings[:bin]      = options["binstubs"] if options["binstubs"]
  Bundler.settings[:bin]      = nil if options["binstubs"] && options["binstubs"].empty?
  Bundler.settings[:shebang]  = options["shebang"] if options["shebang"]
  Bundler.settings[:jobs]     = options["jobs"] if options["jobs"]
  Bundler.settings[:no_prune] = true if options["no-prune"]
  Bundler.settings[:no_install] = true if options["no-install"]
  Bundler.settings[:clean]    = options["clean"] if options["clean"]
  Bundler.settings.without    = options[:without]
  Bundler::Fetcher.disable_endpoint = options["full-index"]
  Bundler.settings[:disable_shared_gems] = Bundler.settings[:path] ? '1' : nil

  # rubygems plugins sometimes hook into the gem install process
  Gem.load_env_plugins if Gem.respond_to?(:load_env_plugins)

  definition = Bundler.definition
  definition.validate_ruby!
  Installer.install(Bundler.root, definition, options)
  Bundler.load.cache if Bundler.root.join("vendor/cache").exist? && !options["no-cache"] && !Bundler.settings[:frozen]

  Bundler.ui.confirm "Bundle complete! #{dependencies_count_for(definition)}, #{gems_installed_for(definition)}."
  confirm_without_groups

  if Bundler.settings[:path]
    absolute_path = File.expand_path(Bundler.settings[:path])
    relative_path = absolute_path.sub(File.expand_path('.'), '.')
    Bundler.ui.confirm "Bundled gems are installed into #{relative_path}."
  else
    Bundler.ui.confirm "Use `bundle show [gemname]` to see where a bundled gem is installed."
  end

  Installer.post_install_messages.to_a.each do |name, msg|
    Bundler.ui.confirm "Post-install message from #{name}:"
    Bundler.ui.info msg
  end

  Installer.ambiguous_gems.to_a.each do |name, installed_from_uri, *also_found_in_uris|
    Bundler.ui.error "Warning: the gem '#{name}' was found in multiple sources."
    Bundler.ui.error "Installed from: #{installed_from_uri}"
    Bundler.ui.error "Also found in:"
    also_found_in_uris.each { |uri| Bundler.ui.error "  * #{uri}" }
    Bundler.ui.error "You should add a source requirement to restrict this gem to your preferred source."
    Bundler.ui.error "For example:"
    Bundler.ui.error "    gem '#{name}', :source => '#{installed_from_uri}'"
  end

  if Bundler.settings[:clean] && Bundler.settings[:path]
    require "bundler/cli/clean"
    Bundler::CLI::Clean.new(options).run
  end
rescue GemNotFound, VersionConflict => e
  if options[:local] && Bundler.app_cache.exist?
    Bundler.ui.warn "Some gems seem to be missing from your vendor/cache directory."
  end

  unless Bundler.definition.has_rubygems_remotes?
    Bundler.ui.warn <<-WARN, :wrap => true
      Your Gemfile has no gem server sources. If you need gems that are \
      not already on your machine, add a line like this to your Gemfile:
      source 'https://rubygems.org'
    WARN
  end
  raise e
end